type KV<T> = Record<string, T>;
type State = KV<unknown>;
type DirectiveKV = KV<DirectiveData>;
interface DirectiveData {
    compute: (state: KV<unknown>, event?: Event) => any;
    value: string;
    deps: string[];
}
interface ASTNode {
    directives: DirectiveKV;
    deps: string[];
    el: HTMLElement;
    type: ASTNodeType;
}
declare enum ASTNodeType {
    NULL = -1,
    STATIC = 0,
    DYNAMIC = 1
}
declare class Component {
    state: State;
    ast: ASTNode[];
    constructor(state: State);
    mount(el: HTMLElement | string): void;
    render(props?: string[]): void;
}
declare const component: (state: State) => Component;
declare const init: (element?: HTMLElement | Document) => void;
export { init, component };
